/* Prototypes for all functions. */

/* Definition of PUBLIC and PRIVATE */
#ifndef PUBLIC
#define PUBLIC
#endif
#ifndef PRIVATE
#define PRIVATE
#endif

PRIVATE MPI_Context MPII_new_context ();
PRIVATE int MPII_queue_init (MPII_Msg_queue *qu);
PRIVATE int MPII_enqueue (MPII_Msg_queue *qu, MPII_Msg *data);
PRIVATE int MPII_queue_search (int *retry, MPII_Msg_queue *qu, int (*match) (void *, MPII_Msg *), void *arg, MPII_Msg *result);
PUBLIC int MPI_Barrier (MPI_Comm comm);
PUBLIC int MPI_Bcast (void *buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm);
PUBLIC int MPI_Comm_rank (MPI_Comm comm, int *rank);
PUBLIC int MPI_Comm_size (MPI_Comm comm, int *size);
PUBLIC MPI_Comm MPII_comm_world (void);
PUBLIC int MPI_Errhandler_create (MPI_Handler_function *function, MPI_Errhandler *errhandler);
PUBLIC void MPI_Errhandler_get (MPI_Comm comm, MPI_Errhandler *errhandler);
PUBLIC void MPI_Errhandler_set (MPI_Comm comm, MPI_Errhandler errhandler);
PUBLIC int MPII_Error (MPI_Comm comm, int code);
PUBLIC int MPI_Error_class (int errorcode, int *errorclass);
PUBLIC int MPI_Error_string (int errorcode, char *string, int *resultlen);
PUBLIC void MPII_Fatal_error (MPI_Comm *comm, int *errorcode);
PUBLIC void MPII_Exit (int rval);
PUBLIC int MPI_Finalize (void);
    PRIVATE extern int MPII_Stack_size_val;
PUBLIC int *MPII_Stack_size_ptr (void);
    PRIVATE extern int MPII_Num_proc_val;
PUBLIC int *MPII_Num_proc_ptr (void);
    PRIVATE extern Key MPII_commworld_key;
    PRIVATE extern Key MPII_me_key;
    PRIVATE extern MPI_Request MPII_Request_null_val;
PUBLIC MPI_Request *MPII_Request_null_ptr (void);
PUBLIC int MPI_Init (int *argc, char ***argv);
PRIVATE void *MPII_Malloc (MPI_Comm comm, int size);
PRIVATE void MPII_Malloc_error (MPI_Comm comm);
PRIVATE MPII_Member *MPII_Me (MPI_Comm comm);
PRIVATE void MPII_Tsd_master_init (Thread id, int n);
PRIVATE void MPII_Tsd_slave_init (Thread id);
PRIVATE void MPII_New_tsd (Key *key);
PRIVATE void *MPII_Get_tsd (Key *key);
PRIVATE void MPII_Set_tsd (Key *key, void *val);
PUBLIC double MPI_Wtime (void);
PUBLIC int MPI_Get_count (MPI_Status *status, MPI_Datatype *datatype, int *count);
PUBLIC int MPI_Irecv (void *buf, int count, MPI_Datatype datatype, int source, int tag, MPI_Comm comm, MPI_Request *request);
PUBLIC int MPI_Issend (void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
PRIVATE int MPII_match_send (MPI_Request *request, MPII_Msg *msg);
PRIVATE int MPII_match_recv (MPI_Request *request, MPII_Msg *msg);
PUBLIC int MPI_Recv (void *buf, int count, MPI_Datatype datatype, int source, int tag, MPI_Comm comm, MPI_Status *status);
PUBLIC int MPI_Recv_init (void *buf, int count, MPI_Datatype datatype, int source, int tag, MPI_Comm comm, MPI_Request *request);
PUBLIC int MPI_Ssend (void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
PUBLIC int MPI_Ssend_init (void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
PUBLIC int MPI_Start (MPI_Request *request);
PUBLIC int MPI_Wait (MPI_Request *request, MPI_Status *status) ;
PUBLIC int MPI_Waitall (int count, MPI_Request *requests, MPI_Status *statuses);
PUBLIC MPI_Datatype MPII_Make_type (int size, int id);
