#include "mpii.h"

/* For threading.h */
#if defined(PTHREADS)
    pthread_attr_t MPII_temp_attrib;
    pthread_mutexattr_t MPII_temp_mattrib;
    pthread_condattr_t MPII_temp_cattrib;
#elif defined(SOLARIS_THREADS)
#endif
void *MPII_temp_ptr;

/* Stack size of each spawned thread.  0 indicates the default (one megabyte).
 * Otherwise measured in bytes.  Set to as low as possible!
 * Currently only implemented for Solaris threads (not possible in POSIX).
 */
#if 0
    PRIVATE extern int MPII_Stack_size_val;
#endif
int MPII_Stack_size_val = 0;
PUBLIC int *MPII_Stack_size_ptr (void)
{
    return &MPII_Stack_size_val;
}

/* Number of processors to use.  This corresponds to the concurrency level
 * in Solaris threads, and has no equivalent for POSIX threads.  For those
 * familiar with Solaris threads, this is implemented with the THR_NEW_LWP
 * option to thr_create().
 */
#if 0
    PRIVATE extern int MPII_Num_proc_val;
#endif
int MPII_Num_proc_val = 1;
PUBLIC int *MPII_Num_proc_ptr (void)
{
    return &MPII_Num_proc_val;
}

/* Global keys */
#if 0
    PRIVATE extern Key MPII_commworld_key;
    PRIVATE extern Key MPII_me_key;
#endif
Key MPII_commworld_key;
Key MPII_me_key;

/* Other globals */
#if 0
    PRIVATE extern MPI_Request MPII_Request_null_val;
#endif
MPI_Request MPII_Request_null_val = {0, 0, MPII_REQUEST_NULL, NULL, NULL, -1,
    {-1, -1}, -1, -2};
PUBLIC MPI_Request *MPII_Request_null_ptr (void)
{
    return &MPII_Request_null_val;
}

