#include "mpii.h"

#if defined(POSIX_4D9)
#   include <sys/timers.h>
#else
#   include <sys/time.h>
#endif

PUBLIC double MPI_Wtime (void)
{
#  if defined(POSIX_4D9)
      struct timespec tp;
      getclock (TIMEOFDAY, &tp);
      return tp.tv_sec + (tp.tv_nsec / 1000000000.0);
#  else
      struct timeval tp;
      gettimeofday (&tp, NULL);
      return tp.tv_sec + (tp.tv_usec / ((double) 1000000.0));
#  endif
}

